## r-cran-glmnet 2.0

=== DESCRIPTION ===
Package: glmnet
Type: Package
Title: Lasso and Elastic-Net Regularized Generalized Linear Models
Version: 2.0-16
Date: 2018-03-12
Author: Jerome Friedman [aut, cre],
	Trevor Hastie [aut, cre],
	Rob Tibshirani [aut, cre],
	Noah Simon [aut, ctb],
	Balasubramanian Narasimhan [ctb],
	Junyang Qian [ctb]
Maintainer: Trevor Hastie <hastie@stanford.edu>
Depends: Matrix (>= 1.0-6), utils, foreach
Imports: methods
Suggests: survival, knitr, lars
Description: Extremely efficient procedures for fitting the entire lasso or elastic-net regularization path for linear regression, logistic and multinomial regression models, Poisson regression and the Cox model. Two recent additions are the multiple-response Gaussian, and the grouped multinomial regression. The algorithm uses cyclical coordinate descent in a path-wise fashion, as described in the paper linked to via the URL below.
License: GPL-2
VignetteBuilder: knitr
URL: http://www.jstatsoft.org/v33/i01/.
NeedsCompilation: yes
Packaged: 2018-03-12 04:20:32 UTC; hastie
Repository: CRAN
Date/Publication: 2018-04-02 12:06:40 UTC

## r-cran-glmnet 2.0-2

=== debian/changelog ===
r-cran-glmnet (2.0-2-2~bpo8+1) jessie-backports; urgency=medium

  * Build for jessie-backports.

 -- Daniel Pocock <daniel@pocock.pro>  Wed, 02 Mar 2016 07:42:38 +0100

r-cran-glmnet (2.0-2-2) unstable; urgency=medium

  * Add more build dependencies. (Closes: #815383)

 -- Daniel Pocock <daniel@pocock.pro>  Thu, 25 Feb 2016 10:18:38 +0100

r-cran-glmnet (2.0-2-1) unstable; urgency=medium

  * Initial packaging (Closes: #815128)

 -- Daniel Pocock <daniel@pocock.pro>  Thu, 18 Feb 2016 21:43:55 +0100

=== debian/control ===
Source: r-cran-glmnet
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Daniel Pocock <daniel@pocock.pro>
Section: gnu-r
Priority: optional
Build-Depends: debhelper (>= 9),
               r-base-dev (>= 3.0.0),
               cdbs,
               r-cran-matrix,
               r-cran-foreach
Standards-Version: 3.9.6
Vcs-Browser: http://anonscm.debian.org/cgit/debian-science/r-cran-glmnet.git
Vcs-Git: git://anonscm.debian.org/debian-science/r-cran-glmnet.git
Homepage: http://cran.r-project.org/web/packages/glmnet

Package: r-cran-glmnet
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${R:Depends},
         r-cran-foreach,
         libjs-mathjax
Description: Lasso and Elastic-Net Regularized Generalized Linear Models
 Extremely efficient procedures for fitting the entire lasso or elastic-net
 regularization path for linear regression, logistic and multinomial
 regression models, Poisson regression and the Cox model. Two recent
 additions are the multiple-response Gaussian, and the grouped multinomial.
 The algorithm uses cyclical coordinate descent in a path-wise fashion, as
 described in the paper Introduction to Glmnet.

=== debian/watch ===
version=3
http://cran.r-project.org/src/contrib/glmnet_([-0-9\.]*)\.tar\.gz

## r-cran-glmnet 2.0-5

=== debian/changelog ===
r-cran-glmnet (2.0-5-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * cme fix dpkg-control
  * Convert to dh-r
  * Canonical homepage for CRAN
  * debhelper 10
  * d/watch: version=4

 -- Andreas Tille <tille@debian.org>  Sun, 04 Dec 2016 22:09:58 +0100

=== debian/control ===
--- 
+++ 
@@ -3,23 +3,24 @@
 Uploaders: Daniel Pocock <daniel@pocock.pro>
 Section: gnu-r
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10),
                r-base-dev (>= 3.0.0),
-               cdbs,
+               dh-r,
                r-cran-matrix,
                r-cran-foreach
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Vcs-Browser: http://anonscm.debian.org/cgit/debian-science/r-cran-glmnet.git
-Vcs-Git: git://anonscm.debian.org/debian-science/r-cran-glmnet.git
-Homepage: http://cran.r-project.org/web/packages/glmnet
+Vcs-Git: https://anonscm.debian.org/git/debian-science/r-cran-glmnet.git
+Homepage: https://cran.r-project.org/package=glmnet
 
 Package: r-cran-glmnet
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          ${R:Depends},
-         r-cran-foreach,
          libjs-mathjax
+Recommends: ${R:Recommends}
+Suggests: ${R:Suggests}
 Description: Lasso and Elastic-Net Regularized Generalized Linear Models
  Extremely efficient procedures for fitting the entire lasso or elastic-net
  regularization path for linear regression, logistic and multinomial

=== debian/watch ===
version=4
http://cran.r-project.org/src/contrib/glmnet_([-0-9\.]*)\.tar\.gz

## r-cran-glmnet 2.0-13

=== debian/changelog ===
r-cran-glmnet (2.0-13-1) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * New upstream version
  * Secure URI in watch file
  * Standards-Version: 4.1.1
  * Testsuite: autopkgtest-pkg-r

  [ Sébastien Villemot ]
  * Fix Vcs-* URLs. (Closes: #818602)

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 05 Nov 2017 11:28:48 +0100

r-cran-glmnet (2.0-10-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.1.0 (no changes needed)

 -- Andreas Tille <tille@debian.org>  Fri, 08 Sep 2017 14:44:52 +0200

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,16 @@
 Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Daniel Pocock <daniel@pocock.pro>
 Section: gnu-r
+Testsuite: autopkgtest-pkg-r
 Priority: optional
 Build-Depends: debhelper (>= 10),
                r-base-dev (>= 3.0.0),
                dh-r,
                r-cran-matrix,
                r-cran-foreach
-Standards-Version: 3.9.8
-Vcs-Browser: http://anonscm.debian.org/cgit/debian-science/r-cran-glmnet.git
-Vcs-Git: https://anonscm.debian.org/git/debian-science/r-cran-glmnet.git
+Standards-Version: 4.1.1
+Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/r-cran-glmnet.git
+Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/r-cran-glmnet.git
 Homepage: https://cran.r-project.org/package=glmnet
 
 Package: r-cran-glmnet

## r-cran-glmnet 2.0-16

=== debian/changelog ===
r-cran-glmnet (2.0-16-2) unstable; urgency=medium

  * Team upload.
  * Maintainer: Debian R Packages Maintainers
  * Standards-Version: 4.2.1
  * Fix VCS fields.

 -- Dylan Aïssi <daissi@debian.org>  Mon, 10 Dec 2018 17:32:45 +0100

r-cran-glmnet (2.0-16-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.1.3
  * debhelper 11

 -- Andreas Tille <tille@debian.org>  Wed, 04 Apr 2018 22:29:44 +0200

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,17 @@
 Source: r-cran-glmnet
-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian R Packages Maintainers <r-pkg-team@alioth-lists.debian.net>
 Uploaders: Daniel Pocock <daniel@pocock.pro>
 Section: gnu-r
 Testsuite: autopkgtest-pkg-r
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper (>= 11~),
                r-base-dev (>= 3.0.0),
                dh-r,
                r-cran-matrix,
                r-cran-foreach
-Standards-Version: 4.1.1
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/r-cran-glmnet.git
-Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/r-cran-glmnet.git
+Standards-Version: 4.2.1
+Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-glmnet
+Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-glmnet.git
 Homepage: https://cran.r-project.org/package=glmnet
 
 Package: r-cran-glmnet

## r-cran-glmnet 2.0-18

=== debian/changelog ===
r-cran-glmnet (2.0-18-1) unstable; urgency=medium

  * Replace Daniel by me as Uploader
  * New upstream version
  * debhelper 12
  * Standards-Version: 4.4.0

 -- Andreas Tille <tille@debian.org>  Tue, 16 Jul 2019 21:38:26 +0200

=== debian/control ===
--- 
+++ 
@@ -1,25 +1,24 @@
 Source: r-cran-glmnet
 Maintainer: Debian R Packages Maintainers <r-pkg-team@alioth-lists.debian.net>
-Uploaders: Daniel Pocock <daniel@pocock.pro>
+Uploaders: Andreas Tille <tille@debian.org>
 Section: gnu-r
 Testsuite: autopkgtest-pkg-r
 Priority: optional
-Build-Depends: debhelper (>= 11~),
-               r-base-dev (>= 3.0.0),
+Build-Depends: debhelper (>= 12~),
                dh-r,
+               r-base-dev,
                r-cran-matrix,
                r-cran-foreach
-Standards-Version: 4.2.1
+Standards-Version: 4.4.0
 Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-glmnet
 Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-glmnet.git
 Homepage: https://cran.r-project.org/package=glmnet
 
 Package: r-cran-glmnet
 Architecture: any
-Depends: ${shlibs:Depends},
-         ${misc:Depends},
-         ${R:Depends},
-         libjs-mathjax
+Depends: ${R:Depends},
+         ${shlibs:Depends},
+         ${misc:Depends}
 Recommends: ${R:Recommends}
 Suggests: ${R:Suggests}
 Description: Lasso and Elastic-Net Regularized Generalized Linear Models

## r-cran-glmnet 3.0

=== DESCRIPTION ===
Package: glmnet
Type: Package
Title: Lasso and Elastic-Net Regularized Generalized Linear Models
Version: 3.0-2
Date: 2019-12-09
Authors@R: c(person("Jerome", "Friedman", role=c("aut")),
	     person("Trevor", "Hastie", role=c("aut", "cre"), email = "hastie@stanford.edu"),
	     person("Rob", "Tibshirani", role=c("aut")),
	     person("Balasubramanian", "Narasimhan", role=c("aut")),
	     person("Noah", "Simon", role=c("aut")),
	     person("Junyang", "Qian", role=c("ctb")))
Depends: R (>= 3.6.0), Matrix (>= 1.0-6)
Imports: methods, utils, foreach, shape
Suggests: survival, knitr, lars
Description: Extremely efficient procedures for fitting the entire lasso or elastic-net regularization path for linear regression, logistic and multinomial regression models, Poisson regression and the Cox model. Two recent additions are the multiple-response Gaussian, and the grouped multinomial regression. The algorithm uses cyclical coordinate descent in a path-wise fashion, as described in the papers listed in the URL below.
License: GPL-2
VignetteBuilder: knitr
Encoding: UTF-8
URL: https://glmnet.stanford.edu,
        https://dx.doi.org/10.18637/jss.v033.i01,
        https://dx.doi.org/10.18637/jss.v039.i05
RoxygenNote: 6.1.1
NeedsCompilation: yes
Packaged: 2019-12-11 01:55:13 UTC; hastie
Author: Jerome Friedman [aut],
  Trevor Hastie [aut, cre],
  Rob Tibshirani [aut],
  Balasubramanian Narasimhan [aut],
  Noah Simon [aut],
  Junyang Qian [ctb]
Maintainer: Trevor Hastie <hastie@stanford.edu>
Repository: CRAN
Date/Publication: 2019-12-11 17:00:02 UTC

## r-cran-glmnet 3.0-2

=== debian/changelog ===
r-cran-glmnet (3.0-2-1) unstable; urgency=medium

  * Team upload.
  * New upstream version

 -- Dylan Aïssi <daissi@debian.org>  Mon, 30 Dec 2019 23:29:20 +0100

r-cran-glmnet (3.0-1-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Sat, 16 Nov 2019 08:46:43 +0100

r-cran-glmnet (3.0-1) unstable; urgency=medium

  * New upstream version
  * debhelper-compat 12
  * Standards-Version: 4.4.1
  * Set upstream metadata fields: Archive.

 -- Andreas Tille <tille@debian.org>  Tue, 12 Nov 2019 11:34:56 +0100

=== debian/control ===
--- 
+++ 
@@ -4,12 +4,13 @@
 Section: gnu-r
 Testsuite: autopkgtest-pkg-r
 Priority: optional
-Build-Depends: debhelper (>= 12~),
+Build-Depends: debhelper-compat (= 12),
                dh-r,
                r-base-dev,
                r-cran-matrix,
-               r-cran-foreach
-Standards-Version: 4.4.0
+               r-cran-foreach,
+               r-cran-shape
+Standards-Version: 4.4.1
 Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-glmnet
 Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-glmnet.git
 Homepage: https://cran.r-project.org/package=glmnet

## r-cran-glmnet 4.0-2

=== debian/changelog ===
r-cran-glmnet (4.0-2-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * debhelper-compat 13 (routine-update)

 -- Dylan Aïssi <daissi@debian.org>  Thu, 16 Jul 2020 09:14:52 +0200

r-cran-glmnet (4.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.5.0 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)

 -- Dylan Aïssi <daissi@debian.org>  Sat, 23 May 2020 12:10:48 +0200

=== debian/control ===
--- 
+++ 
@@ -4,16 +4,18 @@
 Section: gnu-r
 Testsuite: autopkgtest-pkg-r
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                dh-r,
                r-base-dev,
                r-cran-matrix,
                r-cran-foreach,
-               r-cran-shape
-Standards-Version: 4.4.1
+               r-cran-shape,
+               r-cran-survival
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-glmnet
 Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-glmnet.git
 Homepage: https://cran.r-project.org/package=glmnet
+Rules-Requires-Root: no
 
 Package: r-cran-glmnet
 Architecture: any

## r-cran-glmnet 4.1

=== DESCRIPTION ===
Package: glmnet
Type: Package
Title: Lasso and Elastic-Net Regularized Generalized Linear Models
Version: 4.1-6
Date: 2022-11-25
Authors@R: c(person("Jerome", "Friedman", role=c("aut")),
	     person("Trevor", "Hastie", role=c("aut", "cre"), email = "hastie@stanford.edu"),
	     person("Rob", "Tibshirani", role=c("aut")),
	     person("Balasubramanian", "Narasimhan", role=c("aut")),
	     person("Kenneth","Tay",role=c("aut")),
	     person("Noah", "Simon", role=c("aut")),
	     person("Junyang", "Qian", role=c("ctb")),
	     person("James", "Yang", role=c("aut")))
Depends: R (>= 3.6.0), Matrix (>= 1.0-6)
Imports: methods, utils, foreach, shape, survival, Rcpp
Suggests: knitr, lars, testthat, xfun, rmarkdown
SystemRequirements: C++14
Description: Extremely efficient procedures for fitting the entire lasso or elastic-net regularization path for linear regression, logistic and multinomial regression models, Poisson regression, Cox model,  multiple-response Gaussian, and the grouped multinomial regression. There are two new and important additions. The family argument can be a GLM family object, which opens the door to any programmed family. This comes with a modest computational cost, so when the built-in families suffice, they should be used instead.  The other novelty is the relax option, which refits each of the active sets in the path unpenalized. The algorithm uses cyclical coordinate descent in a path-wise fashion, as described in the papers listed in the URL below.
License: GPL-2
VignetteBuilder: knitr
Encoding: UTF-8
URL: https://glmnet.stanford.edu,
        https://dx.doi.org/10.18637/jss.v033.i01,
        https://dx.doi.org/10.18637/jss.v039.i05
RoxygenNote: 7.1.2
LinkingTo: RcppEigen, Rcpp
NeedsCompilation: yes
Packaged: 2022-11-25 19:16:47 UTC; hastie
Author: Jerome Friedman [aut],
  Trevor Hastie [aut, cre],
  Rob Tibshirani [aut],
  Balasubramanian Narasimhan [aut],
  Kenneth Tay [aut],
  Noah Simon [aut],
  Junyang Qian [ctb],
  James Yang [aut]
Maintainer: Trevor Hastie <hastie@stanford.edu>
Repository: CRAN
Date/Publication: 2022-11-27 22:10:02 UTC

=== src/glmnetpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

project("glmnetpp" VERSION 4.2.0
                 DESCRIPTION "A C++ implementation of elastic net solver.")

option(GLMNETPP_ENABLE_TEST         "Enable unit tests to be built."    ON)
option(GLMNETPP_ENABLE_BENCHMARK    "Enable benchmarks to be built."    OFF)
option(GLMNETPP_ENABLE_COVERAGE     "Build glmnetpp with coverage"      OFF)
option(GLMNETPP_MOCK_LEGACY        "Build glmnetpp with mock versions of the fortran."      OFF)

# Define a set of strict build flags
set(GLMNETPP_STRICT_WARNINGS -g -Wall)
if (NOT CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    set(GLMNETPP_STRICT_WARNINGS
        ${GLMNETPP_STRICT_WARNINGS}
        -Wextra -Werror -pedantic)
endif()

# Stoopid hack on windows
if (WIN32)
	SET(CMAKE_FIND_LIBRARY_PREFIXES "")
	SET(CMAKE_FIND_LIBRARY_SUFFIXES ".lib" ".dll")
endif()

# Dependency on Eigen
find_package(Eigen3 3.3 CONFIG REQUIRED NO_MODULE)
message(STATUS "Eigen3 found at ${EIGEN3_INCLUDE_DIR}")

# Set include dirs
set(GLMNETPP_INCLUDEDIR "${${PROJECT_NAME}_SOURCE_DIR}/include")
set(GLMNETPP_SOURCEDIR "${${PROJECT_NAME}_SOURCE_DIR}/src")

# Add this library as shared library.
add_library(${PROJECT_NAME} INTERFACE)

target_include_directories(${PROJECT_NAME} SYSTEM INTERFACE
            $<BUILD_INTERFACE:${GLMNETPP_INCLUDEDIR}>
            $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

# Set C++14 standard for project target
target_compile_features(${PROJECT_NAME} INTERFACE cxx_std_14)

# Set install destinations
install(TARGETS ${PROJECT_NAME}
        EXPORT ${PROJECT_NAME}_Targets
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

# Create GlmnetppConfigVersion.cmake which contains current project version
# This is supposed to help with (major) version compatibility.
include(CMakePackageConfigHelpers)
write_basic_package_version_file("${PROJECT_NAME}ConfigVersion.cmake"
                                 VERSION ${PROJECT_VERSION}
                                 COMPATIBILITY SameMajorVersion)
configure_package_config_file(
    "${PROJECT_SOURCE_DIR}/cmake/${PROJECT_NAME}Config.cmake.in"
    "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
    INSTALL_DESTINATION
    ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}/cmake)

install(EXPORT ${PROJECT_NAME}_Targets
        FILE ${PROJECT_NAME}Targets.cmake
        NAMESPACE ${PROJECT_NAME}::
        DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}/cmake)

install(FILES
        "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
        "${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
        DESTINATION ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}/cmake)

install(DIRECTORY ${PROJECT_SOURCE_DIR}/include DESTINATION ${CMAKE_INSTALL_PREFIX})

# Build source library
if (GLMNETPP_ENABLE_TEST OR GLMNETPP_ENABLE_BENCHMARK)
    if (NOT GLMNETPP_MOCK_LEGACY)
		# MUST be called at the top-level CMakeLists.txt
		enable_language(Fortran)
    endif()
endif()
add_subdirectory(${PROJECT_SOURCE_DIR}/src)

# Automate the choosing of config
# if CMAKE_BUILD_TYPE not defined
if (NOT CMAKE_BUILD_TYPE)
    # if binary directory ends with "release", use release mode
    if (${PROJECT_BINARY_DIR} MATCHES "release$")
        set(CMAKE_BUILD_TYPE RELEASE)
    # otherwise, use debug mode
    else()
        set(CMAKE_BUILD_TYPE DEBUG)
    endif()
endif()
message(STATUS "Compiling in ${CMAKE_BUILD_TYPE} mode")

if (GLMNETPP_ENABLE_TEST)
    # This will perform memcheck
    include(CTest)
    enable_testing()

    # Find googletest
    find_package(GTest 1.11 CONFIG REQUIRED)

    # add test subdirectory
    add_subdirectory(${PROJECT_SOURCE_DIR}/test ${PROJECT_BINARY_DIR}/test)
endif()

if (GLMNETPP_ENABLE_BENCHMARK)
    find_package(benchmark REQUIRED
        HINTS ${CMAKE_CURRENT_SOURCE_DIR}/../../benchmark/build)

    # add benchmark subdirectory
    add_subdirectory(${PROJECT_SOURCE_DIR}/benchmark ${PROJECT_BINARY_DIR}/benchmark)
endif()

=== src/glmnetpp/benchmark/CMakeLists.txt ===
# All macro tests
set(
    BENCHMARKS
    #lasso_stress_benchmark
    gaussian_cov_benchmark
    gaussian_naive_benchmark
    gaussian_benchmark
)

foreach( benchmark ${BENCHMARKS} )
    add_executable(${benchmark} ${CMAKE_CURRENT_SOURCE_DIR}/${benchmark}.cpp)
    target_compile_options(${benchmark} PRIVATE -std=c++17)
    target_include_directories(${benchmark} PRIVATE
        ${PROJECT_SOURCE_DIR}/test
        ${GLMNETPP_SOURCEDIR})
    target_link_libraries(${benchmark}
        benchmark::benchmark_main
        ${PROJECT_NAME}
        legacy
        Eigen3::Eigen)
    if (NOT CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
		target_link_libraries(${benchmark} pthread)
    endif()
endforeach()

=== src/glmnetpp/src/CMakeLists.txt ===
########################################################################
# Legacy Library for compatability tests/benchmarks
########################################################################
if (NOT GLMNETPP_MOCK_LEGACY)
    add_library(legacy
        ${CMAKE_CURRENT_SOURCE_DIR}/legacy/wls.f
        ${CMAKE_CURRENT_SOURCE_DIR}/legacy/glmnet5dpclean.f
        ${CMAKE_CURRENT_SOURCE_DIR}/legacy/pb.c
        )
    if (NOT R_INCLUDE_DIR)
        message(FATAL_ERROR
            "R include directory must be provided by the CMake variable R_INCLUDE_DIR. "
            "Run Sys.getenv('R_INCLUDE_DIR') in R interpreter and provide this path. ")
    endif()
    if (NOT R_LIB_DIR)
        message(FATAL_ERROR
            "R lib directory must be provided by the CMake variable R_LIB_DIR. "
            "Run Sys.getenv('R_HOME') in R interpreter, append /lib, "
            "and provide the resulting path. ")
    endif()
    target_compile_options(legacy PRIVATE -Wall -Wextra)
    target_include_directories(legacy PRIVATE ${R_INCLUDE_DIR})
    find_library(RLIB R REQUIRED HINTS ${R_LIB_DIR})
    target_link_libraries(legacy PRIVATE ${RLIB})
endif()

########################################################################
# Add source files to project
########################################################################
target_sources(${PROJECT_NAME} PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}/internal.cpp)
target_include_directories(${PROJECT_NAME} PRIVATE
    ${GLMNETPP_INCLUDEDIR})
set_target_properties(${PROJECT_NAME} PROPERTIES VERSION ${PROJECT_VERSION})

=== src/glmnetpp/test/CMakeLists.txt ===
# Try to find package Threads for the use of pthreads
unset(GLMNETPP_HAS_PTHREAD)
find_package(Threads)
if (CMAKE_USE_PTHREADS_INIT)
    set(GLMNETPP_HAS_PTHREAD ON)
endif()

if (DEFINED GLMNETPP_HAS_PTHREAD)
    set(GLMNETPP_HAS_PTHREAD_MACRO "-DGLMNETPP_HAS_PTHREAD")
endif()

########################################################################
# Utility TEST
########################################################################

add_executable(utility_unittest
    ${CMAKE_CURRENT_SOURCE_DIR}/util/type_traits_unittest.cpp
    )

if (NOT CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_compile_options(utility_unittest PRIVATE -Werror -Wextra -Wpedantic)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    target_compile_options(utility_unittest PRIVATE -fopenmp)
    target_link_libraries(utility_unittest -fopenmp)
endif()
target_compile_options(utility_unittest PRIVATE -g -Wall)
target_include_directories(utility_unittest PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR})
if (GLMNETPP_ENABLE_COVERAGE)
    target_link_libraries(utility_unittest gcov)
endif()
target_link_libraries(utility_unittest
    ${PROJECT_NAME}
    GTest::gtest_main
    Eigen3::Eigen)
if (NOT CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_link_libraries(utility_unittest pthread)
endif()
add_test(utility_unittest utility_unittest)

########################################################################
# Translation TEST
########################################################################

add_executable(translation_unittest
    ${CMAKE_CURRENT_SOURCE_DIR}/translation/elnet_unittest.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/translation/elnet1_unittest.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/translation/elnet2_unittest.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/translation/spelnet_unittest.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/translation/spelnet1_unittest.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/translation/spelnet2_unittest.cpp
    # Explicitly add Fortran source for debugging purposes
    ${GLMNETPP_SOURCEDIR}/legacy/glmnet5dpclean.f
    ${GLMNETPP_SOURCEDIR}/legacy/pb.c   # only needed for fortran code to link to this
    )

if (NOT CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    # DO NOT put -Werror because Fortran gives a bunch of warnings that we unfortunately cannot change.
    target_compile_options(translation_unittest PRIVATE -Wextra -Wpedantic)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    target_compile_options(translation_unittest PRIVATE -fopenmp)
    target_link_libraries(translation_unittest -fopenmp)
endif()
target_compile_options(translation_unittest PRIVATE -g -Wall)
target_compile_definitions(translation_unittest PRIVATE
    ${GLMNETPP_HAS_PTHREAD_MACRO})
# This is if we can't compile Fortran code,
# but we still want to run our C++ method.
# We enable the mocked version of the legacy Fortran code.
if (GLMNETPP_MOCK_LEGACY)
    target_compile_definitions(translation_unittest PRIVATE
    -DGLMNETPP_MOCK_LEGACY)
endif()
target_include_directories(translation_unittest PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${R_INCLUDE_DIR}
    ${GLMNETPP_SOURCEDIR})
if (GLMNETPP_ENABLE_COVERAGE)
    target_link_libraries(translation_unittest gcov)
endif()
target_link_libraries(translation_unittest
    ${PROJECT_NAME}
    GTest::gtest_main
    Eigen3::Eigen)
if (NOT GLMNETPP_MOCK_LEGACY)
    target_link_libraries(translation_unittest ${RLIB})
endif()
if (NOT CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_link_libraries(translation_unittest pthread)
endif()
add_test(translation_unittest translation_unittest)

########################################################################
# Elnet Path TEST
########################################################################

add_executable(elnet_path_unittest
    ${CMAKE_CURRENT_SOURCE_DIR}/elnet_path/gaussian_cov_unittest.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/elnet_path/gaussian_naive_unittest.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/elnet_path/sp_gaussian_cov_unittest.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/elnet_path/sp_gaussian_naive_unittest.cpp
    )

if (NOT CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_compile_options(elnet_path_unittest PRIVATE -Werror -Wextra -Wpedantic)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    target_compile_options(elnet_path_unittest PRIVATE -fopenmp)
    target_link_libraries(elnet_path_unittest -fopenmp)
endif()
target_compile_options(elnet_path_unittest PRIVATE -g -Wall)
target_compile_definitions(elnet_path_unittest PRIVATE
    ${GLMNETPP_HAS_PTHREAD_MACRO})
target_include_directories(elnet_path_unittest PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${GLMNETPP_SOURCEDIR})
if (GLMNETPP_ENABLE_COVERAGE)
    target_link_libraries(elnet_path_unittest gcov)
endif()
target_link_libraries(elnet_path_unittest
    ${PROJECT_NAME}
    GTest::gtest_main
    Eigen3::Eigen)
if (NOT CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_link_libraries(elnet_path_unittest pthread)
endif()
add_test(elnet_path_unittest elnet_path_unittest)

########################################################################
# Elnet Driver TEST (Integration Test)
########################################################################

add_executable(elnet_driver_unittest
    ${CMAKE_CURRENT_SOURCE_DIR}/elnet_driver/gaussian_unittest.cpp
    )

if (NOT CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_compile_options(elnet_driver_unittest PRIVATE -Werror -Wextra -Wpedantic)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    target_compile_options(elnet_driver_unittest PRIVATE -fopenmp)
    target_link_libraries(elnet_driver_unittest -fopenmp)
endif()
target_compile_options(elnet_driver_unittest PRIVATE -g -Wall)
target_compile_definitions(elnet_driver_unittest PRIVATE
    ${GLMNETPP_HAS_PTHREAD_MACRO})
target_include_directories(elnet_driver_unittest PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${GLMNETPP_SOURCEDIR})
if (GLMNETPP_ENABLE_COVERAGE)
    target_link_libraries(elnet_driver_unittest gcov)
endif()
target_link_libraries(elnet_driver_unittest
    ${PROJECT_NAME}
    GTest::gtest_main
    Eigen3::Eigen)
if (NOT CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_link_libraries(elnet_driver_unittest pthread)
endif()
add_test(elnet_driver_unittest elnet_driver_unittest)

########################################################################
# Core TEST
########################################################################

add_executable(core_unittest
    ${CMAKE_CURRENT_SOURCE_DIR}/wls_unittest.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/standardize_unittest.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/chkvars_unittest.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/internal_unittest.cpp
    )

if (NOT CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_compile_options(core_unittest PRIVATE -Werror -Wextra -Wpedantic)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    target_compile_options(core_unittest PRIVATE -fopenmp)
    target_link_libraries(core_unittest -fopenmp)
endif()
target_compile_options(core_unittest PRIVATE -g -Wall)
target_compile_definitions(core_unittest PRIVATE ${GLMNETPP_HAS_PTHREAD_MACRO})
target_include_directories(core_unittest PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${GLMNETPP_SOURCEDIR})
if (GLMNETPP_ENABLE_COVERAGE)
    target_link_libraries(core_unittest gcov)
endif()
target_link_libraries(core_unittest
    ${PROJECT_NAME}
    GTest::gtest_main
    Eigen3::Eigen)
if (NOT GLMNETPP_MOCK_LEGACY)
    target_link_libraries(core_unittest legacy)
endif()
if (NOT CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_link_libraries(core_unittest pthread)
endif()
add_test(core_unittest core_unittest)

=== debian/changelog ===
r-cran-glmnet (4.1-2) unstable; urgency=medium

  * Depends: libjs-mathjax (thanks for the hint to Andreas Beckmann)
    Closes: #988880

 -- Andreas Tille <tille@debian.org>  Fri, 21 May 2021 11:50:10 +0200

r-cran-glmnet (4.1-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.5.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 15 Jan 2021 23:26:54 +0100

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
                r-cran-foreach,
                r-cran-shape,
                r-cran-survival
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-glmnet
 Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-glmnet.git
 Homepage: https://cran.r-project.org/package=glmnet
@@ -21,7 +21,8 @@
 Architecture: any
 Depends: ${R:Depends},
          ${shlibs:Depends},
-         ${misc:Depends}
+         ${misc:Depends},
+         libjs-mathjax
 Recommends: ${R:Recommends}
 Suggests: ${R:Suggests}
 Description: Lasso and Elastic-Net Regularized Generalized Linear Models

## r-cran-glmnet 4.1-3

=== debian/changelog ===
r-cran-glmnet (4.1-3-1) unstable; urgency=medium

  * Team Upload.
  [ Andreas Tille ]
  * Disable reprotest

  [ Nilesh Patra ]
  * New upstream version 4.1-3
  * Run dh-update-R

 -- Nilesh Patra <nilesh@debian.org>  Thu, 04 Nov 2021 03:56:14 +0530

r-cran-glmnet (4.1-2-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)

 -- Andreas Tille <tille@debian.org>  Mon, 20 Sep 2021 10:37:23 +0200

=== debian/control ===
--- 
+++ 
@@ -10,8 +10,10 @@
                r-cran-matrix,
                r-cran-foreach,
                r-cran-shape,
-               r-cran-survival
-Standards-Version: 4.5.1
+               r-cran-survival,
+               r-cran-rcpp,
+               r-cran-rcppeigen
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-glmnet
 Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-glmnet.git
 Homepage: https://cran.r-project.org/package=glmnet

## r-cran-glmnet 4.1-4

=== debian/changelog ===
r-cran-glmnet (4.1-4-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Fri, 29 Apr 2022 11:39:07 +0200

## r-cran-glmnet 4.1-6

=== debian/changelog ===
r-cran-glmnet (4.1-6-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 02 Dec 2022 11:38:46 +0100

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
                r-cran-survival,
                r-cran-rcpp,
                r-cran-rcppeigen
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-glmnet
 Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-glmnet.git
 Homepage: https://cran.r-project.org/package=glmnet

## r-cran-glmnet 4.1-7

=== debian/changelog ===
r-cran-glmnet (4.1-7-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)

 -- Andreas Tille <tille@debian.org>  Wed, 21 Jun 2023 16:35:37 +0200

## r-cran-glmnet 4.1-8

=== debian/changelog ===
r-cran-glmnet (4.1-8-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Fri, 25 Aug 2023 13:14:20 +0200

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
                r-cran-survival,
                r-cran-rcpp,
                r-cran-rcppeigen
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-glmnet
 Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-glmnet.git
 Homepage: https://cran.r-project.org/package=glmnet

=== debian/watch ===
version=4
https://cran.r-project.org/src/contrib/glmnet_([-0-9\.]*)\.tar\.gz

## r-cran-glmnet 4.1-10

=== debian/changelog ===
r-cran-glmnet (4.1-10-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.7.3 (routine-update)
  * Restrict to 64-bits architectures (routine-update)
  * Restrict to little-endian architectures (routine-update)
  * dh-update-R to update Build-Depends (routine-update)

 -- Charles Plessy <plessy@debian.org>  Thu, 25 Dec 2025 11:30:26 +0900

=== debian/control ===
--- 
+++ 
@@ -12,8 +12,10 @@
                r-cran-shape,
                r-cran-survival,
                r-cran-rcpp,
-               r-cran-rcppeigen
-Standards-Version: 4.6.2
+               r-cran-rcppeigen,
+               architecture-is-64-bit,
+               architecture-is-little-endian
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/r-pkg-team/r-cran-glmnet
 Vcs-Git: https://salsa.debian.org/r-pkg-team/r-cran-glmnet.git
 Homepage: https://cran.r-project.org/package=glmnet
